def addColons(timelist):
    """
        The purpose of this function is to take a list of HMS times (no colons) and output a list of H:M:S times (with colons).
    Input:
    timelist: a list of HMS times without colons
    Output:
    timelist: newly formatted list of H:M:S times with colons
    """

    count = 0
    for time in timelist:
        while (len(time) < 8):
            time = "0" + time
            timelist[count] = time
        count = count + 1
        
    count = 0
    for time in timelist:
        temp = []
        temp.append(time[0:2])
        temp.append(time[2:4])
        temp.append(time[4:])
        timelist[count] = temp[0] + ":" + temp[1] + ":" + temp[2]
        count = count + 1
    return timelist
#returns the inputted list of times with colons format

def formatTimeInts(file, foutput="time.select"):
    """
        The purpose of this function is to take a file in the format of the output of "timeops.py" and create a string
    from the data that is in the correct format to use with the miriad option: select=
    Input:
    file: The name of the file that contains data in the format of a "timeops.py" output
    Output:
    timestring: A string that is formatted correctly to use with the miriad option: select=
    This will allow the selection of all the time intervals of a track
    """

    import carmatable as ct
    tableIn = ct.CarmaTable()
    tableIn.open(file)
    starttimes = tableIn.getCol(0)
    endtimes = tableIn.getCol(1)
    sources = tableIn.getCol(2)

    starttimes = addColons(starttimes)
    endtimes = addColons(endtimes)

    fout = open(foutput, 'w')
    timestring = ""
    for (sTime,eTime) in zip(starttimes,endtimes):
        #timestring = timestring + "time(" + sTime + "," + eTime + ")\n"
        timestring = "time(" + sTime + "," + eTime + ")"
        if (timestring.find("?") == -1):
            fout.write(timestring)
            fout.write("\n")
    #timestring = timestring[:-1]
    #return timestring
    #fout = open("time.select", 'w')
    ######################################### TEMPORARY FIX
    
    #fout.write(timestring)
    ################################
    fout.close()

#timestring = formatTimeInts("cx265.1A_115NGC126.3.txt")
#print timestring
