#! /bin/csh -f
#
#  some stats on calibration
#
foreach w (Means: Medians: Rms:)
  grep $w cx323.1E_89NGC133.?/uvdata.*pb.gplist   > gains_$w.tab
  grep $w cx323.1E_89NGC133.??/uvdata.*pb.gplist >> gains_$w.tab
  grep $w cx323.1D_89NGC133.?/uvdata.*pb.gplist  >> gains_$w.tab
  grep $w cx323.1D_89NGC133.??/uvdata.*pb.gplist >> gains_$w.tab

end

foreach ant (`seq 23`)
  awk -F: '{print $3}' gains_Means:.tab   | tabmath - - %$ant all > $ant.mea
  awk -F: '{print $3}' gains_Medians:.tab | tabmath - - %$ant all > $ant.med
  awk -F: '{print $3}' gains_Rms:.tab     | tabmath - - %$ant all > $ant.rms
  paste $ant.mea $ant.med $ant.rms > $ant.tab
  rm    $ant.mea $ant.med $ant.rms 
  tabplot $ant.tab 0 1 0 24 0 2 dycol=3 point=2,0.05 yapp=$ant.ps/vps
end



set w = "I flux density:"
grep "$w" cx323.1E_89NGC133.?/cal1.log   | awk '{print $NF}'  > flux.tab
grep "$w" cx323.1E_89NGC133.??/cal1.log  | awk '{print $NF}' >> flux.tab
grep "$w" cx323.1D_89NGC133.?/cal1.log   | awk '{print $NF}' >> flux.tab
grep "$w" cx323.1D_89NGC133.??/cal1.log  | awk '{print $NF}' >> flux.tab

tabplot flux.tab 0 1 0 24 0 16 point=2,0.05 yapp=flux.ps/vps  


#
tabstat gains_Means:.tab 2:24 xmin=0.01 > gains_Means:stats.log
set m=(`grep ^mean gains_Means:stats.log`)
set d=(`grep ^disp gains_Means:stats.log`)
set a=(`seq 0 23`)
rm -f gains_Means:stats.tab
foreach i (`seq 2 24`)
  echo $a[$i] $m[$i] $d[$i] >> gains_Means:stats.tab
end
tabplot gains_Means:stats.tab 1 2 0 24 0.6 1.4 dycol=3 point=2,0.1 xlab=Ant ylab=Gain yapp=gains_Means:stats.ps/vps


#
tabstat gains_Medians:.tab 2:24 xmin=0.01 > gains_Medians:stats.log
set m=(`grep ^mean gains_Medians:stats.log`)
set d=(`grep ^disp gains_Medians:stats.log`)
set a=(`seq 0 23`)
rm -f gains_Medians:stats.tab
foreach i (`seq 2 24`)
  echo $a[$i] $m[$i] $d[$i] >> gains_Medians:stats.tab
end
tabplot gains_Medians:stats.tab 1 2 0 24 0.6 1.4 dycol=3 point=2,0.1 xlab=Ant ylab=Gain yapp=gains_Medians:stats.ps/vps


# plot the flux of 3C84 from the CARMA flux table

calflux source=3c84 freq=90 delfreq=20 > 3c84.calflux


#  check 
piperun n1333.lis bootflux_grep > bootflux.tab

tabplot bootflux.tab 0 7,9 0 160 10 14 \
    dycol=8,10 line=0,0,1,1 point=2,0.1 color=2,3 \
    xlab=Observation ylab=Flux_3C84 yapp=bootflux.ps/vcps

tabhist bootflux.tab 7 10 14 xlab=Flux_3C84 yapp=bootflux-histo.ps/vps
